//----------------------------------------------------------------------------
//  The Frogs Of War By Linus Sphinx (c)Copyright 2005 all rights reserved
//----------------------------------------------------------------------------
//
//    This file is part of Linus Sphinx's Frogs Of War II
//
//    Frogs Of War II is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Frogs Of War II is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Frogs Of War II; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//
//--------------------------------------------------------------------------------
// battle frog character display
//--------------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <SDL.h>
#include "frogs.h"
#include "util.h"
#include "player.h" // for score display
#include "chardisp.h"

extern SDL_Surface *Screen;
extern PLAYER Player[];
extern OPTIONS Option;
extern ONSCREENDISPLAY Chardisp;
extern short Me; // my place in player array
extern short Level;
extern long Now;

//-----------------------------------------------------------------
// constructor
//-----------------------------------------------------------------
void chardispinit( void )

{
	int i;
	Chardisp.show = 1;
	Chardisp.top = MAXLINES;
	
	for ( i=0; i < ALPHANUM; i ++ ) // set up our source rects
	{
		Chardisp.Alphabet[ i ].y = 0;
		Chardisp.Alphabet[ i ].h = CHARHIGH;
		Chardisp.Alphabet[ i ].x = i * CHARWIDE;
		Chardisp.Alphabet[ i ].w = CHARWIDE;
	}
	
	Chardisp.lpAlphabet = SDL_LoadBMP( "bmp/alphabet.bmp" );
	SDL_SetColorKey( Chardisp.lpAlphabet, SDL_SRCCOLORKEY, 185 );
	chardispclear();

}
//-----------------------------------------------------------------
// destructor
//-----------------------------------------------------------------
void chardispdestroy( void )
{
	if ( Chardisp.lpAlphabet != NULL )
		SDL_FreeSurface( Chardisp.lpAlphabet );
}
//-----------------------------------------------------------------
// restoreSurfaces
//-----------------------------------------------------------------
void chardisprestoreSurfaces( void )
{
	Chardisp.lpAlphabet = SDL_LoadBMP( "bmp/alphabet.bmp" );
}
//-----------------------------------------------------------------
// draw( LPDIRECTDRAWSURFACE ) rock through the lines to display and blt our rects
//-----------------------------------------------------------------
void chardispdraw( SDL_Surface *surface )
{
	int i, j, k, scorelen, scoreleft;
	short letter;
	char scorestr[ 40 ]; // 999,999,999
	RECT drect = { 0, 0, 0 , 0 };
	
	if ( Chardisp.show )
	{
		for ( i = Chardisp.top, k = 1; i < MAXLINES; i++,k++ ) // first do from top to bottom
		{
			for ( j = 0; j < MAXLENGTH && Chardisp.display[ i ].life; j++ ) 
			{
				if ( Chardisp.display[i].str[j] == '\0' )
					j = MAXLENGTH;
				else
				{
					if ( Chardisp.display[ i ].str[ j ] > 47 && Chardisp.display[ i ].str[ j ] < 58 ) // isnum
						letter = Chardisp.display[ i ].str[ j ] - 48;
					else if ( Chardisp.display[ i ].str[ j ] > 64 && Chardisp.display[ i ].str[ j ] < 91 ) 
						letter = Chardisp.display[ i ].str[ j ] - 55; // upper case
					else if ( Chardisp.display[ i ].str[ j ] > 96 && Chardisp.display[ i ].str[ j ] < 123 ) // lower case
						letter = Chardisp.display[ i ].str[ j ] - 87;
					else if ( Chardisp.display[ i ].str[ j ] == 58 ) // colon
						letter = 36;
					else if ( Chardisp.display[ i ].str[ j ] == 47 ) // slash 
						letter = 37;
					else if ( Chardisp.display[ i ].str[ j ] == 46 ) // period
						letter = 38;
					else
						continue; // skip it
					drect.x = MARGIN + j * CHARWIDE;
					drect.y = k * (CHARHIGH + LEADING);
					if (SDL_BlitSurface( Chardisp.lpAlphabet, &Chardisp.Alphabet[ letter ], surface, &drect ) == -2)
						chardisprestoreSurfaces();
				}
			}
		}

		for ( i = 0; i < Chardisp.top; i++,k++ ) // then do from 0 to top
		{
			for ( j = 0; j < MAXLENGTH && Chardisp.display[ i ].life; j++ )
			{
				if ( Chardisp.display[i].str[j] == '\0' )
					j = MAXLENGTH;
				else
				{
					if ( Chardisp.display[ i ].str[ j ] > 47 && Chardisp.display[ i ].str[ j ] < 58 )
						letter = Chardisp.display[ i ].str[ j ] - 48;
					else if ( Chardisp.display[ i ].str[ j ] > 64 && Chardisp.display[ i ].str[ j ] < 91 ) 
						letter = Chardisp.display[ i ].str[ j ] - 55; // upper case
					else if ( Chardisp.display[ i ].str[ j ] > 96 && Chardisp.display[ i ].str[ j ] < 123 ) // lower case
						letter = Chardisp.display[ i ].str[ j ] - 87;
					else if ( Chardisp.display[ i ].str[ j ] == 58 ) // colon
						letter = 36;
					else if ( Chardisp.display[ i ].str[ j ] == 47 ) // slash 
						letter = 37;
					else if ( Chardisp.display[ i ].str[ j ] == 46 ) // period
						letter = 38;
					else
						continue; // skip it
					drect.x = MARGIN + j * CHARWIDE;
					drect.y = k * (CHARHIGH + LEADING);
				 	if (SDL_BlitSurface( Chardisp.lpAlphabet, &Chardisp.Alphabet[ letter ], surface, &drect )) 
						chardisprestoreSurfaces();
				}
			}
		}
		for ( i = 0; i < MAXLINES; i++ )
		{
			if ( Chardisp.display[ i ].life )			  // don't revive them
				Chardisp.display[ i ].life--;
			if ( Chardisp.display[ i ].life > LINELIFE )
				Chardisp.display[ i ].life = 0;			// kill the oldest line
		}
	}
	sprintf( scorestr, "LEVEL %d", Level );
	scorelen = strlen( scorestr );
	for ( j = 0; j < scorelen; j++ )
	{
		if ( scorestr[j] == '\0' )
			j = MAXLENGTH;
		else
		{
			if ( scorestr[ j ] > 47 && scorestr[ j ] < 58 )
				letter = scorestr[ j ] - 48; // isnum
			else if ( scorestr[ j ] > 64 && scorestr[ j ] < 91 ) 
				letter = scorestr[ j ] - 55; // upper case
			else
				continue; // skip it
			drect.x = MARGIN + ( j * CHARWIDE );
			drect.y = LEADING;
			if (SDL_BlitSurface( Chardisp.lpAlphabet, &Chardisp.Alphabet[ letter ], surface, &drect ))
				chardisprestoreSurfaces();
		}
	}

	sprintf( scorestr, "%02lu:%02lu:%02lu:%02lu", (((Now / 18) / 60) / 60) / 60 % 60, ((Now / 18) / 60) / 60 % 60, ((Now / 18 ) / 60 )% 60, (Now /18) % 60 ); 
	scorelen = strlen( scorestr );
	for ( j = 0; j < scorelen; j++ )
	{
		if ( scorestr[j] == '\0' )
			j = MAXLENGTH;
		else
		{
			if ( scorestr[ j ] > 47 && scorestr[ j ] < 58 )
				letter = scorestr[ j ] - 48;
			else if ( scorestr[ j ] > 64 && scorestr[ j ] < 91 ) 
				letter = scorestr[ j ] - 55; // upper case
			else if ( scorestr[ j ] == 58 ) // colon
				letter = 36;
			else	
				continue; // skip it
			scoreleft = ( SCREENWIDTH / 2 )-(( scorelen * CHARWIDE ) / 2);
			drect.x = scoreleft + ( j * CHARWIDE );
			drect.y = LEADING;
			if (SDL_BlitSurface( Chardisp.lpAlphabet, &Chardisp.Alphabet[ letter ], surface, &drect ))
				chardisprestoreSurfaces();
		}
	}

	sprintf( scorestr, "FROG %d", Player[ 0 ].bc ); 
	scorelen = strlen( scorestr );
	for ( j = 0; j < scorelen; j++ )
	{
		if ( scorestr[j] == '\0' )
			j = MAXLENGTH;
		else
		{
			if ( scorestr[ j ] > 47 && scorestr[ j ] < 58 )
				letter = scorestr[ j ] - 48;
			else if ( scorestr[ j ] > 64 && scorestr[ j ] < 91 ) 
				letter = scorestr[ j ] - 55; // upper case
			else	
				continue; // skip it
			scoreleft = ( SCREENWIDTH - MARGIN )-( scorelen * CHARWIDE );
			drect.x = scoreleft + ( j * CHARWIDE );
			drect.y = LEADING;
			if (SDL_BlitSurface( Chardisp.lpAlphabet, &Chardisp.Alphabet[ letter ], surface, &drect ))
				chardisprestoreSurfaces();
		}
	}
}
//-----------------------------------------------------------------
// void addaline( char * ) add a line to display bottom and scroll up
//-----------------------------------------------------------------
void chardispaddaline( char *linetoadd )
{
	Chardisp.top--;
	memset( Chardisp.display[ Chardisp.top ].str, '\0', MAXLENGTH );
	strncpy( Chardisp.display[ Chardisp.top ].str, linetoadd, MAXLENGTH - 1 );
	Chardisp.display[ Chardisp.top ].life = LINELIFE;
	if ( Chardisp.top == 0 )
		Chardisp.top = MAXLINES;
}
//-----------------------------------------------------------------
// void xy( int x, int y, char * string, int h ) paint a string at x and y highlighting h if > -1
//-----------------------------------------------------------------
void chardispdrawxy( SDL_Surface *surface, int x, int y, char *str, int h )
{
	int j, len;
	short letter;
	RECT drect = { 0, 0, 0 , 0 };
	RECT hlite = { 466, 0, 429 , 18 };
	len = strlen( str );
	for ( j = 0; j < len; j++ )
	{
		if ( str[ j ] > 47 && str[ j ] < 58 )
			letter = str[ j ] - 48;
		else if ( str[ j ] > 64 && str[ j ] < 91 ) 
			letter = str[ j ] - 55; // upper case
		else if ( str[ j ] == 58 ) // colon
			letter = 36;
		else if ( str[ j ] == ' ' ) 
			letter = 39;
		else
			continue; // skip it
		drect.x = x + ( j * CHARWIDE );
		drect.y = y;
		if (SDL_BlitSurface( Chardisp.lpAlphabet, &Chardisp.Alphabet[ letter ], surface, &drect ))
			chardisprestoreSurfaces();
		if ( h == j )
		{
			drect.x -= 2;
			drect.y -= 2;
			if ( SDL_BlitSurface( Chardisp.lpAlphabet, &hlite, surface, &drect ))
				chardisprestoreSurfaces();
		}
	}
}
//-----------------------------------------------------------------
// void clear(void) empty all lines and set top to zero
//-----------------------------------------------------------------
void chardispclear( void )
{
	int i;

	for ( i=0; i < MAXLINES; i++ )
	{								   
		memset( Chardisp.display[ i ].str, '\0', MAXLENGTH );
		Chardisp.display[ i ].life = 0;
	}
	Chardisp.top = MAXLINES;
}
//-----------------------------------------------------------------
// short has(char *) return TRUE if message in display already
//-----------------------------------------------------------------
short chardisphas( char *msg )
{
	int i, retval = 1;
	
	for ( i = 0; retval && i < MAXLINES; i++ )
	{
		if ( Chardisp.display[ i ].life )								
			retval = strncmp( msg, Chardisp.display[ i ].str, strlen( msg ));
	}
	return( retval );
}
//-----------------------------------------------------------------
// void bull(char *filename) clear, read and display text file
//-----------------------------------------------------------------
void chardispbull( char *fname )
{
	int hfile;
	int i = 0, j = 0;
	int actual = 0, sizeofile;
	char *text = NULL;
	char str[ MAXLENGTH + 1];
	
	hfile = open( fname, O_RDONLY );
	
	if ( hfile > 1 )
	{
		sizeofile = lseek( hfile, 0L, SEEK_END );
		lseek( hfile, 0L, SEEK_SET );
		text = (char *)calloc( sizeofile + 1, sizeof(char));	
		actual = read( hfile, text, sizeofile );
		text[ sizeofile ] = '\0';
		str[ 0 ] = '\0';
		chardispclear();
		if ( actual == sizeofile )
		{
			memset( str, '\0', sizeof( str ));
			while ( i < sizeofile && j < MAXLENGTH ) // if line is too long bail out
			{
				str[ j ] = text[ i ];
				if ( str[ j ] == '\n' )
				{
					str[ j ] = '\0';
					chardispaddaline( str );
					j = 0;
				}
				else
					j++;
				i++;
			}
		}
		if ( text != NULL )
			free( text );
		close( hfile );
	}
}
//-----------------------------------------------------------------
//-----------------------------------------------------------------

