//  The Frogs Of War By Linus Sphinx (c)Copyright 2005 all rights reserved
//----------------------------------------------------------------------------
//
//    This file is part of Linus Sphinx's Frogs Of War II
//
//    Frogs Of War II is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Frogs Of War II is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Frogs Of War II; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//
//--------------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <pthread.h>
#include <SDL.h>
#include <SDL_mixer.h>
#include "frogs.h"
#include "racket.h"
#include "util.h"
#include "sprite.h"
#include "player.h"
#include "tank.h"
#include "room.h"
#include "helm.h"
#include "chardisp.h"
#include "magi.h"
#include "ceo.h"
#include "topten.h"

SDL_Surface *Screen;
SDL_Joystick *joystick;
RECT rect = {0,0,SCREENWIDTH,SCREENHEIGHT};
PLAYER Player[ PLAYERMAX ];
ROSTER Roster[ PLAYERMAX ];
TANKS Tank;
ROOM Room;
ROOM Room;
ONSCREENDISPLAY Chardisp;
HELM Helm;
OPTIONS Option;
MAGI Magi;
CEO Ceo;
Mix_Chunk **Noise; // global array of sounds
Mix_Chunk *Song;
short CurrentPalette = 0; // palette effect
short Me = 0;
short Winner = -1;
short Helmon = 1;
short Pause = 0;
short Level = 1;
short PLAYERS = 2;
int rate = 83; // frameage set to 55 after level 1
int saved = 0; // top ten not written
extern unsigned long Now; // util.c

/* unsigned short far Draghand[ 32 ] = // mouse cursor hot spot 0 0
{
	0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
	0xf000, 0x2e00, 0x1e80, 0x0de0, 0x03d0, 0x01f8, 0x187c, 0x7376,
	0x779f, 0x075f, 0xf6df, 0xf69e, 0xd87d, 0x7ffa, 0x3bb5, 0x1bea
}; */

//-----------------------------------------------
// void hitanykey(void) - wait for a key press
// ----------------------------------------------
void hitanykey()
{
	int anykey = 0;
	SDL_Event event;

	while(!anykey)
	{
		while( SDL_PollEvent( &event ))
		{
			switch( event.type )
			{
				case SDL_JOYBUTTONDOWN:
					switch(event.jbutton.button)
					{
						case GP2X_BUTTON_A: 
						case GP2X_BUTTON_B: 
						case GP2X_BUTTON_X: 
						case GP2X_BUTTON_Y:
                   		case GP2X_BUTTON_SELECT:
                   		case GP2X_BUTTON_START:
						case GP2X_BUTTON_R:
						case GP2X_BUTTON_CLICK:
						case GP2X_BUTTON_L:
							break;
							continue;
						case GP2X_BUTTON_VOLUP:
							racketvolume( 8 );
							continue;
						case GP2X_BUTTON_VOLDOWN:
							racketvolume( -8 );
						default:
							continue;
					}
				case SDL_KEYDOWN:
				case SDL_MOUSEBUTTONDOWN: // click
					switch( event.key.keysym.sym )
					{
						case SDLK_f:
							SDL_WM_ToggleFullScreen( Screen );
							continue;
					//	case SDLK_g:
					//		SDL_BlitSurface( Chardisp.lpAlphabet, NULL, Screen, NULL );
					//		SDL_Flip( Screen );
					//		continue;
					//
						case SDLK_n:
						case SDLK_q:
						case SDLK_ESCAPE:
						default :
							Pause = 0;
							anykey++;
							break;
					}
					break;
				case SDL_QUIT: /* SDL_QUIT event (window close) */
				default:
					break;
			}
		}
	}
}

//----------------------------------------
// help display
//----------------------------------------
void help()
{
	setPaletteColor( Screen, 0 );
	Pause = 1;
	rect.x = 0;
	rect.w = SCREENWIDTH;
	rect.y = 0;
	rect.h = SCREENHEIGHT;
	SDL_SetClipRect( Screen, &rect );
	toptenshow( Screen );
	Pause = 1;
	hitanykey();
	loadbmp( Screen, "bmp/buttons.bmp", 1 );
	Pause = 1;
	hitanykey();
	loadbmp( Screen, "bmp/play.bmp", 1 );
	Pause = 1;
	hitanykey();
	paintscreen( Screen, 252 );
	chardispaddaline("http://www.fullsack.com");
	Pause = 0;
}


//------------------------------------------------------------------
// short doevents(void) - process events and return 1 on quit keys 
//------------------------------------------------------------------
short doevents()
{
	static short oneshot=0;
	SDL_Event event;
	int i;
#ifndef GP2X
	int mx, my; // mouse xy
	char outstr[256] = "";
#else
	int rdown = 0, ldown = 0;
#endif
	while( SDL_PollEvent( &event ))
	{
		switch( event.type )
		{
			case SDL_QUIT: /* SDL_QUIT event (window close) */
				return( 1 );
#ifdef GP2X
        	case SDL_JOYBUTTONDOWN:
				switch(event.jbutton.button)
				{
					// case GP2X_BUTTON_X: 
					// case GP2X_BUTTON_B: 
					case GP2X_BUTTON_A: 
					case GP2X_BUTTON_CLICK:
						oneshot++;
						Helm.leftcurlever = 1; // trigger
						playerleftClickFire( Me, Helm.curtool );
						break;

					case GP2X_BUTTON_Y: // rotate weapons
						Helm.leftcurlever = 0;
						if ( ! oneshot )
						{
							oneshot++;
							Helm.curtool--;
						}
						break;

					case GP2X_BUTTON_UP:
						Helm.rightcurlever = 2;
						playerdoubleClickFlip( Me );
						break;

					case GP2X_BUTTON_UPLEFT:
						Helm.rightcurlever = 2;
						playerclickupleft( Me );
						playerleftClickJump( Me );
						break;

					case GP2X_BUTTON_UPRIGHT:
						Helm.rightcurlever = 2;
						playerclickupright( Me );
						playerleftClickJump( Me );
						break;

					case GP2X_BUTTON_R:
						rdown = 1;
						Helm.leftcurlever = 0;
						if ( ldown && rdown )
							return( 1 );
						else
							chardispclear();
							nextrack();
						break;

					case GP2X_BUTTON_L:
						ldown = 1;
						if ( ldown && rdown )
							return( 1 );
						help();
						break;

					case GP2X_BUTTON_LEFT:
						Helm.rightcurlever = 3;
						playerleftClickRection( Me );
						break;

					case GP2X_BUTTON_RIGHT:
						Helm.rightcurlever = 3;
						playerrightClickRection( Me );
						break;

					case GP2X_BUTTON_DOWN:
						Helm.rightcurlever = 2;
						playerclickcenterstop( Me );
						break;

					case GP2X_BUTTON_DOWNLEFT:
						Helm.rightcurlever = 2;
						playerleftClickRection( Me );
						playerrightClickJump( Me );
						break;

					case GP2X_BUTTON_DOWNRIGHT:
						Helm.rightcurlever = 2;
						playerrightClickRection( Me );
						playerrightClickJump( Me );
						break;

                    case GP2X_BUTTON_SELECT:
						Pause = !Pause;
						break;

					case GP2X_BUTTON_START:
						Helmon = 1;
						if ( Level >= MAXLEVEL)
						{
							Level=2;
							Winner = Me;
						}
						for ( i = 0; i < PLAYERS; i++ )
						{
							playerrefresh( i );
						}
						setRobotsXy();
						break;
					case GP2X_BUTTON_VOLUP:
						racketvolume( 8 );
						break;
					case GP2X_BUTTON_VOLDOWN:
						racketvolume( -8 );
						break;
				}
				break;

			case SDL_JOYBUTTONUP:
				switch(event.jbutton.button)
				{
					case GP2X_BUTTON_A: 
					case GP2X_BUTTON_X: 
					case GP2X_BUTTON_B: 
					case GP2X_BUTTON_Y: 
						oneshot = 0;
						if ( Pause )
							Pause = !Pause;
						break;
					case GP2X_BUTTON_L:
						ldown=0;
						break;
					case GP2X_BUTTON_R:
						rdown=0;
						break;
				}
#endif
				break;
#ifndef GP2X
			case SDL_MOUSEBUTTONDOWN: // click
				switch( event.button.button )
				{
					case 1:  // LEFTBUTTONCLICK
						Helm.leftcurlever = 1;
						if( ! oneshot )
						{
							oneshot++;
							playerleftClickFire( Me, Helm.curtool );
						}
						break;
					case 3:  // RIGHTBUTTONCLICK
						Helm.leftcurlever = 0;
						if ( ! oneshot )
						{
							oneshot++;
							Helm.curtool--;
						}
					default:
						break;
				}
				break;
			case SDL_MOUSEBUTTONUP:
				switch( event.button.button ) // released
				{
					case 1 :  // LEFTBUTTON
					case 3 :  // RIGHTBUTTON
						//printf("buttonup %d\n", event.button.button);
						oneshot = 0;
					default:
						break;
				}
				break;
			case SDL_MOUSEMOTION: // the mouse, she has moved
				/* printf("Mouse moved by %d,%d to (%d,%d)\n", 
					event.motion.xrel, event.motion.yrel,
					event.motion.x, event.motion.y); */
				my = event.motion.y;
				mx = event.motion.x;
			 	if ( my < TOPTHIRD ) // jump
				{
					Helm.rightcurlever = 2;
					if ( mx < LEFTTHIRD ) // top left
					{
						playerclickupleft( Me );
						playerleftClickJump( Me );
					}
					else if( mx < RIGHTTHIRD ) // top middle
					{
						playerdoubleClickFlip( Me );
					}
					else if ( mx > RIGHTTHIRD ) // top right
					{
						playerclickupright( Me );
						playerleftClickJump( Me );
					}
				}
				else if ( my < BOTTOMTHIRD ) // center row
				{
					Helm.rightcurlever = 2;
					if ( mx < LEFTTHIRD ) // left
					{
						playerleftClickRection( Me );
					}
					else if( mx < RIGHTTHIRD ) // middle
					{ 
						playerclickcenterstop( Me );
					}
					else if ( mx > RIGHTTHIRD ) // right
					{
						playerrightClickRection( Me );
					}
				}
				else if ( my > BOTTOMTHIRD ) // bottom row
				{
					Helm.rightcurlever = 3;
					if ( mx < LEFTTHIRD ) //  left
					{
						playerrightClickJump( Me );
					}
					else if( mx < RIGHTTHIRD ) // middle
					{
						playerrightClickJump( Me );
					}
					else if ( mx > RIGHTTHIRD ) // right
					{
						playerrightClickJump( Me );
					}
				}
				break;
			case SDL_KEYDOWN:
				switch( event.key.keysym.sym )
				{
					case SDLK_ESCAPE:
					case SDLK_q: 
                        return( 1 ); // bail out of main loop
					case SDLK_f:
						SDL_WM_ToggleFullScreen( Screen );
						continue;
					case SDLK_h:
						Helmon = !Helmon;
						paintscreen( Screen, 0 );
						continue;
					case SDLK_p:
						Pause = !Pause;
						continue;
					case SDLK_n:
						Winner = Me; 
						continue;
					case SDLK_l:
						help();
						continue;
					case SDLK_r:
						Helm.leftcurlever = 0;
						chardispclear();
						nextrack();
						continue;
					case SDLK_LSHIFT:
						Helm.leftcurlever = 0; // switch hands
						Helm.curtool--; // change tool
						break;
					case SDLK_LCTRL:  
						Helm.leftcurlever = 1; // fuego
						playerleftClickFire( Me, Helm.curtool );
						break;
					case SDLK_UP:
						Helm.rightcurlever = 2;
						playerleftClickJump( Me );
						break;
					case SDLK_DOWN:
						Helm.rightcurlever = 2;
						playerrightClickJump( Me );
						break;
					case SDLK_LEFT:
						Helm.rightcurlever = 3;
						playerleftClickRection( Me );
						break;
					case SDLK_RIGHT:
						Helm.rightcurlever = 3;
						playerrightClickRection( Me );
						break;
						
					case SDLK_F6:
						racketvolume( -8 );
						break;
					case SDLK_F7:
						racketvolume( 8 );
						break;
					case SDLK_F8:
						Helmon = 1;
						for ( i = 0; i < PLAYERS; i++ )
						{
							playerrefresh( i );
						}
						setRobotsXy();
						if ( Level > MAXLEVEL)
						{
							Level=2;
							Winner = Me;
						}
						break;

					case SDLK_F9:
						chardispclear();
						for ( i = PLAYERMAX - 1; i >= 0; --i ) 
						{
							sprintf( outstr, "%d: %s hits: %d", i, Roster[ i ].name, Player[ i ].bc );
							chardispaddaline( outstr );
						}
						sprintf( outstr, "missles %d x:%d y:%d", Tank.misslecount, Player[Me].x, Player[Me].y );
						chardispaddaline( outstr );
						sprintf( outstr, "level: %d  players: %d", Level, PLAYERS );
						chardispaddaline( outstr );
						break;
					default :
						break;
			}
#endif
		}

	}
    return( 0 );
}

//----------------------------------------
// void draw(void) - paint a screen load
//----------------------------------------
int draw()
{
	char outstr[256] = "";
	int retval = 1;

	rect.x = 0;
	rect.w = SCREENWIDTH;
	rect.y = 0;
	if ( Winner == Me )
	{
		if ( Level < MAXLEVEL )
		{
			rate = 55; // kick it
			racketplay( 15, 0 ); // opening blast
			chardispclear();
			switch( ++Level )
			{
				case 2:
					PLAYERS = 3;
					sprintf( outstr, "threes company" );
					break;
				case 3:
					PLAYERS = 4;
					sprintf( outstr, "fours a crowd" );
					break;
				case 4:
					PLAYERS = 5;
					sprintf( outstr, "take the fifth" );
					break;
				case 5:
					PLAYERS = 7;
					sprintf( outstr, "lucky seven" );
					break;
				case 6:
					PLAYERS = 8;
					sprintf( outstr, "octowussy" );
					break;
				case 7:
					PLAYERS = 10;
					sprintf( outstr, "top ten" );
					break;
				case 8:
					PLAYERS = 6;
					sprintf( outstr, "no friendly fire" );
					chardispaddaline( outstr );
					sprintf( outstr, "six six sixpack" );
					break;
				default:
					PLAYERS = 2;
					Level = 1;
					break;
			}
			chardispaddaline( outstr );
			sprintf( outstr, "advancing to next level" );
			chardispaddaline( outstr );
			changebacktile( "level", Level );
			setRobotsOnlyXy();
		}
		else if ( Level == MAXLEVEL )
		{
			Level++;
			rect.h = SCREENHEIGHT;
			SDL_SetClipRect( Screen, &rect );
			toptenstoptheclock( Now, Player[ 0 ].bc ); // pencil down
			retval = 0;
		}
	}
	else
	{
		rect.h = SCREENHEIGHT - CONTROLSHEIGHT + OVERLAP;
		SDL_SetClipRect( Screen, &rect );
		roomdraw( Screen );
		tankdraw( Screen );
		roomdrawtop( Screen );
		magidraw( Screen );
		chardispdraw( Screen );
		// clip for helm
		rect.x = 0;
		rect.w = SCREENWIDTH;
		rect.y = SCREENHEIGHT - CONTROLSHEIGHT;
		rect.h = CONTROLSHEIGHT;
		SDL_SetClipRect( Screen, &rect );
		if ( Helmon )
			helmdraw( Screen );
	}
	return( retval );
}

//-----------------------------------------------------------
// void copyleft(void) - logo
//-----------------------------------------------------------
void copyright(void)
{
	fputs("\nFrogs Of War 2x\n", stderr );
	fputs("(c)Copyright Linus Sphinx 2005 All Rights Reserved\n", stderr );
	fputs("http://fullsack.com\n\n", stderr );
}

//-----------------------------------------------------------
// void froghandler(int sig) - handle those annoying signals
//-----------------------------------------------------------
void froghandler(int sig)
{
	fprintf( stderr, "caught signal %d\n", sig );
	fputs("frog halt\n", stderr );
	exit( 1 );
}

//---------------
// main program
//--------------- 
int main( int argc, char **argv )
{

	copyright();
	signal( SIGTERM, froghandler );
	signal( SIGINT, froghandler );

	Option.Sound = 1;
	racketstart();

	if ( SDL_Init( SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK )== -1 )
	{ 
		fprintf( stderr, "Init err: %s.\n", SDL_GetError());
		exit(1);
	}
	Screen = SDL_SetVideoMode( SCREENWIDTH, SCREENHEIGHT, COLORDEPTH, SDL_SWSURFACE | SDL_FULLSCREEN ); // | SDL_DOUBLEBUF ); 
	if ( Screen != NULL )
	{
		if ( SDL_SetColorKey(Screen, SDL_SRCCOLORKEY, 185 ) != 0)
		{
			fprintf(stderr, "Err color key: %s\n", SDL_GetError());
			return 1;
		}
#ifdef GP2X
		joystick = SDL_JoystickOpen(0); 
		if (!joystick) 
		{
			fprintf(stderr, "Err joystick: %s\n", SDL_GetError());
		}
#else
		SDL_WM_SetCaption("Frogs Of War 2x by Linus Sphinx", "Sphinx");
#endif
 		SDL_SetClipRect(Screen, &rect);
		SDL_ShowCursor( SDL_DISABLE );
		toptenload();
		loadbmp( Screen, "bmp/brand.bmp", 1 );
		racketplay( 14, 0 ); // boom
		hitanykey();
		racketplay( 15, 0 ); // laugh
		loadbmp( Screen, "bmp/liz.bmp", 1 );
		playerresetAll();
		chardispinit();
		tankinit();
		roominit();
		helminit();
		magiinit();
		ceoinit();
		setRobotsXy();
		hitanykey();
		racketplay( 0, -1 ); // background sounds
		help();
		while( draw() )
		{
			if ( !Pause )
			{
				whowon();
				tankmove();
				roomcollide();
				SDL_Flip( Screen );
			}
			if ( doevents() )
				break;
			SDL_Delay(timeleft(rate)); // 1/18 = 55 1/12 = 83
		}
		setPaletteColor( Screen, 0 );
		if ( Level > MAXLEVEL )
		{
			if ( topteneligible() )
			{
				while( ! saved )
				{
					ceodraw( Screen );
					saved = toptentry( Screen );
					SDL_Flip( Screen );
					SDL_Delay(timeleft(55)); // 1/18 = 55 1/12 = 83
				}
			}
			else
			{
				loadbmp( Screen, "bmp/notopten.bmp", 0 );
				hitanykey();
			}

		}
		rect.x = 0;
		rect.y = 0;
		rect.w = SCREENWIDTH;
		rect.h = SCREENHEIGHT;
		SDL_SetClipRect(Screen, &rect);
		toptenshow( Screen );
		chardispdestroy();
		magidestroy();
		ceodestroy();
		tankdestroy();
		roomdestroy();
		hitanykey();
		loadbmp( Screen, "bmp/grimfrog.bmp", 0 );
		hitanykey();
		paintscreen( Screen, 0 );
		SDL_Flip( Screen );
	}

	racketstop();
	SDL_Quit();
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
	return(0);
}
// eof
