//----------------------------------------------------------------------------
//  The Frogs Of War By Linus Sphinx (c)Copyright 2005 all rights reserved
//----------------------------------------------------------------------------
//
//    This file is part of Linus Sphinx's Frogs Of War II
//
//    Frogs Of War II is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Frogs Of War II is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Frogs Of War II; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//
//--------------------------------------------------------------------------------
// battle frog helm menu class
//--------------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <SDL.h>
#include "frogs.h"
#include "util.h"
#include "sprite.h"
#include "player.h"
#include "tank.h"
#include "room.h"
#include "helm.h"

extern SDL_Surface *Screen;
extern PLAYER Player[];
extern TANKS Tank; // for missles on scope
extern HELM Helm;
extern short Me; // my place in player array
extern short PLAYERS;

//-----------------------------------------------------------------
// helm initializer
//-----------------------------------------------------------------
void helminit( void )
{
	Helm.leftcurlever = 0;
	Helm.rightcurlever = 3;
	Helm.show = 1;
	Helm.curtool = 0;

	Helm.controls = SDL_LoadBMP( "bmp/control.bmp" );
	Helm.hands = SDL_LoadBMP( "bmp/hands.bmp" );
	SDL_SetColorKey(Helm.controls, SDL_SRCCOLORKEY, 185 );
	SDL_SetColorKey(Helm.hands, SDL_SRCCOLORKEY, 185 );
	
}
//-----------------------------------------------------------------
// destructor
//-----------------------------------------------------------------
void helmdestroy( void )
{
	if ( Helm.controls != NULL )
		SDL_FreeSurface( Helm.controls );
	if ( Helm.hands != NULL )
		SDL_FreeSurface( Helm.hands);
}
//-----------------------------------------------------------------
// draw
//-----------------------------------------------------------------
void helmdraw( SDL_Surface *surface )
{
	int i;
	short bliptouse = 0, diffx, vleft, myscopex;
	POINT nextblip;
	short ox = (SCREENWIDTH - CONTROLSWIDTH) / 2;
	short oy = (SCREENHEIGHT - CONTROLSHEIGHT);
	RECT hands[ 3 ];
   	hands[ 0 ].x = 0;
	hands[ 0 ].y = 0;
	hands[ 0 ].w = 42;
	hands[ 0 ].h = 55;

   	hands[ 1 ].x = 43;
	hands[ 1 ].y = 0;
	hands[ 1 ].w = 41;
	hands[ 1 ].h = 55;

   	hands[ 2 ].x = 147;
	hands[ 2 ].y = 0;
	hands[ 2 ].w = 41;
	hands[ 2 ].h = 55;

	POINT lever[ 4 ]; 
	lever[ 0 ].x = 67;
	lever[ 0 ].y = 7;
   	lever[ 1 ].x = 93;
	lever[ 1 ].y = 9;
	lever[ 2 ].x = 185;
	lever[ 2 ].y = 7;
   	lever[ 3 ].x = 211;
	lever[ 3 ].y = 0;
	RECT controls;
	controls.x = 0;
	controls.y = 0;
	controls.w = 320;
	controls.h = 55;
	RECT tools[ 3 ];
    tools[ 0 ].x = 85;
	tools[ 0 ].y = 0;
	tools[ 0 ].w = 18;
	tools[ 0 ].h = 14;
	tools[ 1 ].x = 85;
	tools[ 1 ].y = 15;
	tools[ 1 ].w = 18;
	tools[ 1 ].h = 14;
	tools[ 2 ].x = 85;
	tools[ 2 ].y = 30;
	tools[ 2 ].w = 18;
	tools[ 2 ].h = 14;
	RECT gauge[ 2 ];
   	gauge[ 0 ].x = 271;
	gauge[ 0 ].y = 19;
	gauge[ 0 ].w = 30;
	gauge[ 0 ].h = 4;
	gauge[ 1 ].x = 275;
	gauge[ 1 ].y = 39;
	gauge[ 1 ].w = 30;
	gauge[ 1 ].h = 4;
	RECT firehand;  
	RECT blip[ 5 ]; // frog states on scope
   	blip[ 0 ].x = 104; // normal
	blip[ 0 ].y = 15;
	blip[ 0 ].w = 2;
	blip[ 0 ].h = 2;
	blip[ 1 ].x = 104; // green    
	blip[ 1 ].y = 18;
	blip[ 1 ].w = 2;
	blip[ 1 ].h = 2;
	blip[ 2 ].x = 104; // blue
	blip[ 2 ].y = 20;
	blip[ 2 ].w = 2;
	blip[ 2 ].h = 2;
	blip[ 3 ].x = 104; // red 
	blip[ 3 ].y = 23;
	blip[ 3 ].w = 2;
	blip[ 3 ].h = 2;
	blip[ 4 ].x = 70; // dust  
	blip[ 4 ].y = 10;
	blip[ 4 ].w = 1;
	blip[ 4 ].h = 1;
	RECT mlip[ 3 ];
   	mlip[ 0 ].x = 99;
	mlip[ 0 ].y = 40;
	mlip[ 0 ].w = 1;
	mlip[ 0 ].h = 1; 
   	mlip[ 1 ].x = 95;
	mlip[ 1 ].y = 20;
	mlip[ 1 ].w = 1;
	mlip[ 1 ].h = 1; 
   	mlip[ 2 ].x = 101;
	mlip[ 2 ].y = 8;
	mlip[ 2 ].w = 1;
	mlip[ 2 ].h = 1; 
	RECT tdest;

	if ( ! Helm.show )
		return;
	// bleet the controls
	tdest.x = ox;
	tdest.y = oy;
	if (SDL_BlitSurface( Helm.controls, NULL, surface, &tdest )== -2 )
		helmrestoreSurfaces();
	// blt the current tool
	if ( Helm.curtool > 2 ) // tool selection rotates
		Helm.curtool = 0;
	if ( Helm.curtool < 0 )
		Helm.curtool = 2;
	tdest.x = 28 + ox;
	tdest.y = oy + 19;
	if (SDL_BlitSurface( Helm.hands, &tools[ Helm.curtool ], surface, &tdest )== -2)
		helmrestoreSurfaces();
	//Blt the hands according to current lever
	switch( Helm.leftcurlever )
	{
		case 0:
			hands[ 0 ].h = HANDSHEIGHT - lever[ Helm.leftcurlever ].y;
			tdest.x = lever[ Helm.leftcurlever ].x + ox;
			tdest.y = oy + lever[ Helm.leftcurlever ].y;
			if (SDL_BlitSurface( Helm.hands, &hands[0], surface, &tdest )== -2)
				helmrestoreSurfaces();
			break;
		case 1:
			hands[ 0 ].h = HANDSHEIGHT - lever[ Helm.leftcurlever ].y;
			tdest.x = lever[ Helm.leftcurlever ].x + ox;
			tdest.y = oy + lever[ Helm.leftcurlever ].y;
			if (SDL_BlitSurface( Helm.hands, &hands[0], surface, &tdest )== -2)
				helmrestoreSurfaces();
			break;
		default:
			Helm.leftcurlever = 0;
	}
	switch( Helm.rightcurlever )
	{
		case 2:
			hands[ 0 ].h = HANDSHEIGHT - lever[ Helm.rightcurlever ].y;
			firehand.x = lever[ Helm.rightcurlever ].x + ox;
			firehand.y = oy + lever[ Helm.rightcurlever ].y;
			if (SDL_BlitSurface( Helm.hands, &hands[2], surface, &firehand )== -2)
				helmrestoreSurfaces();
			break;
		case 3:
			firehand.x = lever[ Helm.rightcurlever ].x + ox;
			firehand.y = oy + lever[ Helm.rightcurlever ].y;
			hands[ 0 ].h = HANDSHEIGHT - lever[ 0 ].y;
			if (SDL_BlitSurface( Helm.hands, &hands[1], surface, &firehand )== -2)
				helmrestoreSurfaces();
			break;
		default:
			Helm.rightcurlever = 3;
	}

	// adjust the gauges
	if ( Player[ Me ].power > 0 )
	{
		gauge[ 0 ].x += ox;
		gauge[ 0 ].y += oy;
		gauge[ 0 ].w = ( Player[ Me ].power / 200 );
		SDL_FillRect( surface, &gauge[0], 139);
	}
	if ( Player[ Me ].shield > 0 )
	{
		gauge[ 1 ].x += ox;
		gauge[ 1 ].y += oy;
		gauge[ 1 ].w = ( Player[ Me ].shield / 400 );
		SDL_FillRect( surface, &gauge[1], 228);
	}

	// frog scope online
	myscopex = Player[ Me ].x / SCOPEXRATIO;

	for ( i=0; i < PLAYERS; i++ )
	{
		nextblip.x = Player[ i ].x / SCOPEXRATIO;

		if ( myscopex > SCOPEHALF ) // horizon in front
		{
			vleft = myscopex - SCOPEHALF;
			diffx = SCOPEWIDE - vleft;		 
			if ( nextblip.x > vleft )
				nextblip.x -= vleft;
			else
				nextblip.x += diffx;
		}
		else if ( myscopex < SCOPEHALF ) // horizon behind
		{
			vleft = myscopex + SCOPEHALF;
			diffx = SCOPEWIDE - vleft;

			if ( nextblip.x > vleft )
				nextblip.x -= vleft;
			else
				nextblip.x += diffx;
		}
		nextblip.x += SCOPELEFT;

		if ( Player[ i ].y <= Player[ Me ].y ) // this player sits high says I
			nextblip.y = SCOPECENTERY - (( Player[ Me ].y - Player[ i ].y ) / SCOPEYRATIO ); 
		if ( Player[ i ].y > Player[ Me ].y )
			nextblip.y = SCOPECENTERY + (( Player[ i ].y - Player[ Me ].y ) / SCOPEYRATIO ); 
				// bottom doesn't wrap
		if ( nextblip.y < SCOPETOP || nextblip.y > SCOPEBOTTOM ) // outta range
			continue;
		if ( nextblip.x < SCOPELEFT || nextblip.x > SCOPERIGHT ) // outta range
			continue;
		switch( Player[ i ].guy ) // show player states on scope
		{
				case SPLATOAD:
					bliptouse = 1;
					break;
				case ZAPZTOAD:
					bliptouse = 2;
					break;
				case REDTOAD1:
				case REDTOAD2:
					bliptouse = 3;
					break;
				case DUSTTOAD:
					if ( Player[ i ].id != Player[ Me ].id )
					 	continue;
				default:
					bliptouse = 0;
					break;
			}
			firehand.x = nextblip.x + ox;
			firehand.y = nextblip.y;
			if (SDL_BlitSurface( Helm.hands, &blip[ bliptouse ], surface, &firehand )== -2)
				helmrestoreSurfaces();
	}

	for ( i=0; i < MISSLECOUNT; i++ )
	{
		if ( Tank.missle[ i ].type == 23 || Tank.missle[ i ].type == 4 || Tank.missle[ i ].type == 8 )
		{				
			nextblip.x = Tank.missle[ i ].x / SCOPEXRATIO;

			if ( myscopex > SCOPEHALF ) // horizon in front
			{
				vleft = myscopex - SCOPEHALF;
				diffx = SCOPEWIDE - vleft;		 
				if ( nextblip.x > vleft )
					nextblip.x -= vleft;
				else
					nextblip.x += diffx;
			}
			else if ( myscopex < SCOPEHALF ) // horizon behind
			{
				vleft = myscopex + SCOPEHALF;
				diffx = SCOPEWIDE - vleft;
	
				if ( nextblip.x > vleft )
					nextblip.x -= vleft;
				else
					nextblip.x += diffx;
			}
			nextblip.x += SCOPELEFT;
	
			if (Tank.missle[ i ].y <= Player[ Me ].y ) 
				nextblip.y = SCOPECENTERY - (( Player[Me].y - Tank.missle[i].y ) / SCOPEYRATIO); 
			if ( Tank.missle[ i ].y > Player[ Me ].y )
				nextblip.y = SCOPECENTERY + (( Tank.missle[i].y - Player[ Me ].y ) / SCOPEYRATIO); 
					// bottom doesn't wrap
			if ( nextblip.y < SCOPETOP || nextblip.y > SCOPEBOTTOM ) // out of range
				continue;

			switch( Tank.missle[ i ].type )
			{
				case 23: // red
					bliptouse = 0;
					break;
				case 4: // green 
					bliptouse = 1;
				case 8: // blue
					bliptouse = 2;
					break;
				default:
					break;
			}
			firehand.x = nextblip.x + ox;
			firehand.y = nextblip.y;
			if (SDL_BlitSurface( Helm.hands, &mlip[ bliptouse ], surface, &firehand )== -2)
				helmrestoreSurfaces();
		}
	}
}
//-----------------------------------------------------------------
// RestoreSurfaces
//-----------------------------------------------------------------
void helmrestoreSurfaces( void )
{
	loadbmp( Helm.controls, "bmp/control.bmp", 0 );
	loadbmp( Helm.hands, "bmp/hands.bmp", 0 );
}
//-----------------------------------------------------------------
//
//-----------------------------------------------------------------

